/* ========================================
 *  Thunder - Thunder.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Thunder_Thunder_H
#define __Thunder_Thunder_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Thunder {
enum {
	kParamA = 0,
	kParamB = 1,
  kNumParameters = 2
}; //


class Thunder final : public SfxCoreExtensionV1
{
public:
    Thunder();
    ~Thunder();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	double muVary;
	double muAttack;
	double muNewSpeed;
	double muSpeedA;
	double muSpeedB;
	double muCoefficientA;
	double muCoefficientB;
	double gateL;
	double gateR;
	double iirSampleAL;
	double iirSampleBL;
	double iirSampleAR;
	double iirSampleBR;
	double iirSampleAM;
	double iirSampleBM;
	double iirSampleCM;
	uint32_t fpdL;
	uint32_t fpdR;
	bool flip;
	
    float A;
    float B;

};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
